const dbManagerFactory = require('../lib').databaseManagerFactory;

describe('Testing dialect aliases', function() {

  const aliases = [
    'pg', 'postgres', 'postgresql', 
    'mysql', 'maria', 'mariadb', 'mariasql', 
    'sqlite', 'sqlite3'
  ];

  aliases.forEach(dialect => {
    it(`should load client with alias "${dialect}"`, () => {
      const manager = dbManagerFactory({ 
        knex: {
          client: dialect
        }
      })
    });
  });

  it(`should fail loading unknown client`, () => {
    const manager = dbManagerFactory({ 
      knex: {
        client: 'foobar'
      }
    })
  });

});

